const TwitterNotifierLogin = {

  util: new naanExUtils("twitternotifier"),
  keyconfig: ["togglePopup", "insertURL"],
  vkNames: [],
  platformKeys: {},
  localKeys: {},
 
  onLoad: function() {

    var $ = this.util.$;
    this.strings = document.getElementById("twitternotifier-strings");

    this.buildUserPopup();

    Components.classes["@mozilla.org/observer-service;1"]
        .getService(Components.interfaces.nsIObserverService)
        .addObserver(this, "twitternotifier-status", false);

    var interval = this.util.pref().getIntPref("interval");
    if (!interval || interval < 3) {
      interval = 3;
    }
    $("refresh-interval").value = interval;

    var popup = this.util.pref().getIntPref("popup-interval");
    if (!popup) {
      popup = 3;
    }
    $("popup-interval").value = popup;

    $("popup-autoclose").checked = this.util.pref().getBoolPref("autoClose");
    $("balloon-popup").checked   = this.util.pref().getBoolPref("popup");

    $("sound").checked         = this.util.pref().getBoolPref("sound");
    $("sound-file").value      = this.util.pref().getCharPref("soundFile");
    $("sound-file").disabled   = !$("sound").checked;
    $("choose-sound").disabled = !$("sound").checked;

    this.localeKeys = document.getElementById("localeKeys");

    var platformKeys = document.getElementById("platformKeys");
    this.platformKeys.shift   = platformKeys.getString("VK_SHIFT");
    this.platformKeys.meta    = platformKeys.getString("VK_META");
    this.platformKeys.alt     = platformKeys.getString("VK_ALT");
    this.platformKeys.control = platformKeys.getString("VK_CONTROL");
    this.platformKeys.sep     = platformKeys.getString("MODIFIER_SEPARATOR");

    pref = Components.classes['@mozilla.org/preferences-service;1']
      .getService(Components.interfaces.nsIPrefService).getBranch("ui.key.");

    switch (pref.getIntPref("accelKey")) {
    case 17:
      this.platformKeys.accel = this.platformKeys.control;
      break;
    case 18: 
      this.platformKeys.accel = this.platformKeys.alt;
      break;
    case 224:
      this.platformKeys.accel = this.platformKeys.meta;
      break;
    default:
      this.platformKeys.accel = (window.navigator.platform.search("Mac") == 0 ?
                                 this.platformKeys.meta : this.platformKeys.control);
    }

    for (var property in KeyEvent) {
      this.vkNames[KeyEvent[property]] = property.replace("DOM_","");
    }
    this.vkNames[8] = "VK_BACK";

    for (var i in this.keyconfig) {
      var pref = this.util.pref().getCharPref(this.keyconfig[i]);
      var param = pref.split(/,/);
      var e = $("twitternotifier-key-" + this.keyconfig[i]);
      e.value = this.getPrintableKeyName(param[2], param[0], param[1]);
      e.initialValue = e.pref = pref;
    }

  },

  onUnload: function() {
    Components.classes["@mozilla.org/observer-service;1"]
        .getService(Components.interfaces.nsIObserverService)
          .removeObserver(this, "twitternotifier-status");
    try {
      window.opener.gTwitterNotifier._prefWindow = null;
    }
    catch (e) {}
  },

  onAddAccount: function() {
    var prompt = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
    var msg = this.strings.getString("AddAccount");
    var user = {value: ""};
    var pass = {value: ""};
    var result = prompt.promptUsernameAndPassword(window, "TwitterFox", msg, user, pass, "", {value:false});
    if (result) {
      this.util.savePassword(user.value, pass.value);
      this.util.pref().setCharPref("currentUser", user.value);
      this.buildUserPopup();
      this.showMessage(this.strings.getFormattedString("AccountAdded", [user.value]));
    }
    this.accountChanged = true;
  },

  onRemoveAccount: function() {
    var prompt = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
    var user = this.util.$("username").value;
    var msg = this.strings.getFormattedString("RemoveAccountConfirm", [user]);
    var result = prompt.confirm(window, "TwitterFox", msg);
    if (result) {
      this.util.removePassword(user);
      this.buildUserPopup();
      this.showMessage(this.strings.getFormattedString("AccountRemoved", [user]));
    }
    this.accountChanged = true;
  },


  onCheckSound: function(flag) {
    document.getElementById('sound-file').disabled = flag;
    document.getElementById('choose-sound').disabled = flag;
  },

  onBrowseFile: function() {
    const nsIFilePicker = Components.interfaces.nsIFilePicker;
    var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
    fp.init(window, this.strings.getString("ChooseSoundFile"), nsIFilePicker.modeOpen);
    if (navigator.platform == "MacPPC" || 
        navigator.platform == "MacIntel") {
      fp.appendFilter(this.strings.getString("SoundFileFilter") + " (*.wav, *.aiff)" , "*.wav; *.aiff");
    }
    else {
      fp.appendFilter(this.strings.getString("SoundFileFilter") + " (*.wav)", "*.wav");
    }

    var ret = fp.show();
    if (ret == nsIFilePicker.returnOK || ret == nsIFilePicker.returnReplace) {
      var file = fp.file;
      this.util.$("sound-file").value = file.path;
    }
  },

  buildUserPopup: function() {
    this.accounts = this.util.getPassword();
    var menu = this.util.$("username");
    while (menu.firstChild) menu.removeChild(menu.firstChild);

    this.util.$("username").value = "";
    this.util.$("password").value = "";

    if (this.accounts == null) {
      this.util.$("username").disabled = true;
      this.util.$("password").disabled = true;
      this.util.$("remove-account-button").disabled = true;
      return;
    }
    else {
      this.util.$("username").disabled = false;
      this.util.$("password").disabled = false;
      this.util.$("remove-account-button").disabled = false;
    }

    var currentUser = this.util.pref().getCharPref("currentUser");
    if (!this.accounts[currentUser]) {
      currentUser = "";
    }

    for (var user in this.accounts) {
      if (this.accounts.hasOwnProperty(user)) {
        menu.appendItem(user, user);
        if (currentUser == "") {
          currentUser = user;
        }
        if (user == currentUser) {
          this.util.$("username").value = user;
          this.util.$("password").value = this.accounts[user];
        }
      }
    }
  },

  showMessage: function(msg) {
    this.util.$("message").value = msg;
  },

  observe: function(subject, topic, data) {
    /* do nothing here */
    return;
  },

  recognize: function(e) {
    e.preventDefault();
    e.stopPropagation();

    var modifiers = [];
    if(e.altKey)   modifiers.push("alt");
    if(e.ctrlKey)  modifiers.push("control");
    if(e.metaKey)  modifiers.push("meta");
    if(e.shiftKey) modifiers.push("shift");

    modifiers = modifiers.join(" ");

    var key = "";
    var keycode = "";
    if(e.charCode) {
      key = String.fromCharCode(e.charCode).toUpperCase();
    }
    else { 
      keycode = this.vkNames[e.keyCode];
      if(!keycode) return;
    }

    var val = this.getPrintableKeyName(modifiers, key, keycode);
    if (val) {
      e.target.value = val;
      e.target.pref = key + "," + keycode + "," + modifiers;
    }

    this.showMessage(this.strings.getString("WarnKeyConfig"));
  },

  revert: function(e) {
    var target = e.target.previousSibling;
    var param = target.initialValue.split(/,/);
    target.value = this.getPrintableKeyName(param[2], param[0], param[1]);
    target.pref  = param[0] + "," + param[1] + "," + param[2];
  },

  getPrintableKeyName: function(modifiers,key,keycode) {
    if(modifiers == "shift,alt,control,accel" && keycode == "VK_SCROLL_LOCK") return "";

    if (!modifiers && !keycode)
      return "";

    var val = "";
    if(modifiers) {
      val = modifiers.replace(/^[\s,]+|[\s,]+$/g,"").split(/[\s,]+/g).join(this.platformKeys.sep);
    }

    var   mod = ["alt", "shift", "control", "meta", "accel"];
    for (var i in mod) {
      val = val.replace(mod[i], this.platformKeys[mod[i]]);
    }

    if (val)
      val += this.platformKeys.sep;

    if(key) {
      val += key;
    }
    if(keycode) {
      try {
        val += this.localeKeys.getString(keycode);
      }
      catch(e) {
        val += keycode;
      }
    }

    return val;
  },

  selectionChanged: function(elem) {
    var name = elem.value;

    this.accountChanged = true;
    try {
      if (this.accounts[name]) {
        this.util.$("password").value = this.accounts[name];
      }
    }
    catch (e) {}
  },

  onChange: function(elem) {
    this.accountChanged = true;
  },

  onSubmit: function() {
    var $ = this.util.$;

    this.util.pref().setIntPref("interval", $("refresh-interval").value);
    this.util.pref().setIntPref("popup-interval", $("popup-interval").value);
    this.util.pref().setBoolPref("autoClose", $("popup-autoclose").checked);
    this.util.pref().setBoolPref("popup", $("balloon-popup").checked);

    this.util.pref().setBoolPref("sound", $("sound").checked);
    this.util.pref().setCharPref("soundFile", $("sound-file").value);

    this.util.savePassword($("username").value,
                           $("password").value);

    for (var i in this.keyconfig) {
      var elem = $("twitternotifier-key-" + this.keyconfig[i]);
      this.util.pref().setCharPref(this.keyconfig[i], elem.pref);
    }

    this.util.notify("updatePref");

    if (this.accountChanged) {
      this.util.pref().setCharPref("currentUser", $("username").value);

      var password = this.util.getAccountInfo();
      this.util.notify("changeAccount", password);
      this.util.pref().setBoolPref("login", true);
    }

    return true;
  },

  onCancel: function() {
    try {
      window.opener.gTwitterNotifier._prefWindow = null;
    }
    catch (e) {}
  }
};

